Namespace: webdriver.promise
View Source

# class Promise<T>

All implemented interfaces
  `IThenable<T>`
  `webdriver.promise.Thenable<T>`

Represents the eventual value of a completed operation. Each promise may be in one of three states: pending, fulfilled, or rejected. Each promise starts in the pending state and may make a single transition to either a fulfilled or rejected state, at which point the promise is considered resolved.

### new Promise(resolver, opt_flow)

Parameters

resolver`function(function(?(T|{then: ?})=): ?, function(*=): ?): ?`

  Function that is invoked immediately to begin computation of this promise's value. The function should accept a pair of callback functions, one for fulfilling the promise and another for rejecting it.

opt_flow`?webdriver.promise.ControlFlow=`

  The control flow this instance was created under. Defaults to the currently active flow.

## Instance Methods

### cancel(opt_reason)code »

Cancels the computation of this promise's value, rejecting the promise in the process. This method is a no-op if the promise has already been resolved.

Specified by: webdriver.promise.Thenable

Parameters

opt_reason`?(string|webdriver.promise.CancellationError)=`

  The reason this promise is being cancelled.

### isPending()code »

Specified by: webdriver.promise.Thenable

Returns

`boolean`

  Whether this promise's value is still being computed.

### then(opt_callback, opt_errback)code »

Registers listeners for when this instance is resolved.

Specified by: webdriver.promise.Thenable, IThenable

Parameters

opt_callback`?function(T): (R|IThenable<R>)=`

  The function to call if this promise is successfully resolved. The function should expect a single argument: the promise's resolved value.

opt_errback`?function(*): (R|IThenable<R>)=`

  The function to call if this promise is rejected. The function should expect a single argument: the rejection reason.

Returns

`webdriver.promise.Promise`

  A new promise which will be resolved with the result of the invoked callback.

### thenCatch(errback)code »

Registers a listener for when this promise is rejected. This is synonymous with the `catch` clause in a synchronous API:

    // Synchronous API:
    try {
      doSynchronousWork();
    } catch (ex) {
      console.error(ex);
    }

    // Asynchronous promise API:
    doAsynchronousWork().thenCatch(function(ex) {
      console.error(ex);
    });

Specified by: webdriver.promise.Thenable

Parameters

errback`function(*): (R|IThenable<R>)`

  The function to call if this promise is rejected. The function should expect a single argument: the rejection reason.

Returns

`webdriver.promise.Promise`

  A new promise which will be resolved with the result of the invoked callback.

### thenFinally(callback)code »

Registers a listener to invoke when this promise is resolved, regardless of whether the promise's value was successfully computed. This function is synonymous with the `finally` clause in a synchronous API:

    // Synchronous API:
    try {
      doSynchronousWork();
    } finally {
      cleanUp();
    }

    // Asynchronous promise API:
    doAsynchronousWork().thenFinally(cleanUp);

Note: similar to the `finally` clause, if the registered callback returns a rejected promise or throws an error, it will silently replace the rejection error (if any) from this promise:

    try {
      throw Error('one');
    } finally {
      throw Error('two');  // Hides Error: one
    }

    promise.rejected(Error('one'))
        .thenFinally(function() {
          throw Error('two');  // Hides Error: one
        });

Specified by: webdriver.promise.Thenable

Parameters

callback`function(): (R|IThenable<R>)`

  The function to call when this promise is resolved.

Returns

`webdriver.promise.Promise`

  A promise that will be fulfilled with the callback result.

### toString()code »

Returns

`string`